#include "EnterNameView.h"
#include <stdio.h>
#include <Window.h>
EnterNameView::EnterNameView(BRect T, int Score) : BView(T,"GameOverView",B_FOLLOW_ALL_SIDES,B_FULL_UPDATE_ON_RESIZE|B_WILL_DRAW|B_PULSE_NEEDED)
{
	SetViewColor(B_TRANSPARENT_COLOR);
	for(int i=0;i<20;i++)
		m_Name[i]=0;
	m_NameLength=0;
	m_Score=Score;

}

void EnterNameView::KeyDown(const char *bytes, int32 numBytes)
{
	if(numBytes==1)
	{
		char	B=*bytes;

		if(B==B_ENTER)
		{
			
			BMessage*	M=new BMessage(MSG_HIGHSCOREENTRY);
			M->AddString("Name",m_Name);
			M->AddInt32("Score",m_Score);
	
			BWindow*	P=Window();
			P->PostMessage(M);
			return;
		}

		if(B==B_BACKSPACE)
		{
			m_Name[--m_NameLength]=0;
			Invalidate();
			return;
		}

		if(m_NameLength<19)
		{
			m_Name[m_NameLength++]=B;
			Invalidate();
		}
	}
}

void	EnterNameView::Draw(BRect updateRect)
{
	MakeFocus();
	BRect	T=Bounds();
	SetHighColor(0,0,0);
	FillRect(T);
	
	SetHighColor(0x55,0x99,0xcc);
	SetLowColor(0x22,0x22,0xaa);

	BFont	MyFont(be_bold_font);
	MyFont.SetSize(40);
	SetFont(&MyFont);
	MovePenTo(15,100);
	DrawString("You have a High-score.");
	MovePenTo(10,140);
	DrawString("Please enter your name:");
	MovePenTo(240-(MyFont.StringWidth(m_Name)/2),185);
	DrawString(m_Name);
}

void	EnterNameView::Pulse()
{
}

void	EnterNameView::WindowActivated(bool active)
{
}

void	EnterNameView::MouseDown(BPoint point)
{
}