#include "GameOverView.h"
#include <be/translation/TranslationUtils.h>
#include <stdio.h>
#include <Window.h>
#include "Defines.h"
#include "Hiscore.h"

extern	Hiscore		GameScores[5];
extern	BPath		GamePath;

GameOverView::GameOverView(BRect T,int Score) : BView(T,"GameOverView",B_FOLLOW_ALL_SIDES,B_FULL_UPDATE_ON_RESIZE|B_WILL_DRAW|B_PULSE_NEEDED)
{
	SetViewColor(0,0,0);

	BPath	P(GamePath);
	P.Append("Gfx/Gameover.bmp");	

	printf("Attemting to load BMP file: %s\n",P.Path());
	m_Bitmap=BTranslationUtils::GetBitmap(P.Path());
	if(m_Bitmap==NULL)
	{
		printf("Error could not load Bitmap: %s\n",P.Path());
		printf("Bailing out!!!!!\n");
		exit(-1);
	}
	else
		printf("Loaded picture: %s\n",P.Path());

	m_Score=Score;
}

void	GameOverView::Draw(BRect updateRect)
{
	BRect	T=Bounds();
	FillRect(T);

	BPoint	dest(10,100);
	DrawBitmap(m_Bitmap,dest);
}

void	GameOverView::Pulse()
{
	static int counter=0;
	
	counter++;
	if(counter==25)
	{
		counter=0;
		printf("Score: %d\n",m_Score);
		
		for(int i=0;i<5;i++)
		{
			if(m_Score>=GameScores[i].Score)
			{
				printf("New highscore. Send message MSG_TOHIGHSCORE\n");
				BMessage*	M=new BMessage(MSG_TOHIGHSCORE);
				M->AddInt32("Score",m_Score);
				
				BWindow*	P=Window();
				P->PostMessage(M);
				return;
			}
		}


		BWindow*	P=Window();
		P->PostMessage(new BMessage(MSG_RETURNTOTITLE));
	}
}

void	GameOverView::WindowActivated(bool active)
{
}

void	GameOverView::MouseDown(BPoint point)
{
}