#include <Application.h>
#include <AppKit.h>
#include "SameWindow.h"
#include "Hiscore.h"
#include <StorageKit.h>
#include <stdio.h>

Hiscore		GameScores[5];

BPath		GamePath;

void	LoadHighscore(void);
void	SaveHighscore(void);

class SameApp : public BApplication
{
public:
	SameApp();
};

SameApp::SameApp() : BApplication("application/x-vnd.MWN-SameGame")
{
	app_info	MyInfo;
	GetAppInfo(&MyInfo);
	
	BEntry	Entry(&MyInfo.ref);
	Entry.GetPath(&GamePath);
	GamePath.GetParent(&GamePath);

//	printf("Initialised program path: %s\n",GamePath.Path());

	LoadHighscore();
	BRect	T(100,100,579,456);
	SameWindow *t=new SameWindow("Same Game",T);
	t->Show();	
}

void	LoadHighscore(void)
{
	BPath	P(GamePath);
	P.Append("Hiscore.dat");
	
	BFile	Fil(P.Path(),B_READ_ONLY);
	
	if(Fil.InitCheck()==B_OK)
	{
		BMessage	Highscore;
		Highscore.Unflatten(&Fil);

		const char*	t;

		t=Highscore.FindString("Name0");		
		Highscore.FindInt32("Score0",(int32 *)&GameScores[0].Score);
		strcpy(&GameScores[0].Name[0],t);

		t=Highscore.FindString("Name1");		
		Highscore.FindInt32("Score1",(int32 *)&GameScores[1].Score);
		strcpy(&GameScores[1].Name[0],t);

		t=Highscore.FindString("Name2");		
		Highscore.FindInt32("Score2",(int32 *)&GameScores[2].Score);
		strcpy(&GameScores[2].Name[0],t);
		
		t=Highscore.FindString("Name3");		
		Highscore.FindInt32("Score3",(int32 *)&GameScores[3].Score);
		strcpy(&GameScores[3].Name[0],t);
		
		t=Highscore.FindString("Name4");		
		Highscore.FindInt32("Score4",(int32 *)&GameScores[4].Score);
		strcpy(&GameScores[4].Name[0],t);
	}
}

void	SaveHighscore(void)
{
	BPath	P(GamePath);
	P.Append("Hiscore.dat");
	
	BFile	Fil(P.Path(),B_WRITE_ONLY|B_CREATE_FILE);
	
	BMessage	M;
	
	M.AddString("Name0",GameScores[0].Name);
	M.AddInt32("Score0",GameScores[0].Score);

	M.AddString("Name1",GameScores[1].Name);
	M.AddInt32("Score1",GameScores[1].Score);

	M.AddString("Name2",GameScores[2].Name);
	M.AddInt32("Score2",GameScores[2].Score);

	M.AddString("Name3",GameScores[3].Name);
	M.AddInt32("Score3",GameScores[3].Score);

	M.AddString("Name4",GameScores[4].Name);
	M.AddInt32("Score4",GameScores[4].Score);
	
	M.Flatten(&Fil);
	
}

int main(void)
{
	SameApp	App;
	App.Run();
	return(0);
}