#ifndef	PLAYVIEW_H
#define PLAYVIEW_H
#include <View.h>
#include "Defines.h"

class	Node
{
public:
	int		m_Type;			// 0-2 for ball type
	int		m_Frame;		// 0-7 for the frame.
	bool	m_Dirty;		// Should this be redrawn
};

class PlayView : public BView
{
public:
	PlayView(BRect T);
	void	Draw(BRect updateRect);
	void	Pulse();
	void	WindowActivated(bool active);
	void	MouseDown(BPoint point); 

	void	ShuffleMatrix(void);
	void	FindAllSelected(int x, int y, int type);


private:
	bool	CheckIfGameOver(void);
	void	CopyColumn(int Source,int Dest);
	bool	IsColumnEmpty(int Source);


	Node		Matrix[15][10];
	bool		SelectedMatrix[15][10];
	
	uchar	Colors[5][3];
	
	BBitmap*	m_Bitmap;
	BPoint		m_MousePoint;
	bool		m_MouseInside;
	bool		m_Active;

	int			m_SelectCount;
	int			m_Score;
};

#endif