#include "SameWindow.h"
#include <InterfaceKit.h>
#include "Defines.h"
#include "Hiscore.h"
#include <stdio.h>

extern	Hiscore		GameScores[5];
extern	void	LoadHighscore(void);
extern	void	SaveHighscore(void);


SameWindow::SameWindow(char *AWindowTitle, BRect AFrame) : BWindow(AFrame,AWindowTitle,B_TITLED_WINDOW,B_NOT_RESIZABLE|B_FRAME_EVENTS)
{
	BRect		T=Bounds();
	T.bottom=T.top+19;
	BMenuBar	*B=new BMenuBar(T,"MenuBar");
	
	BMenu	*B1=new BMenu("Project");
	B->AddItem(B1);

	BMenuItem	*B2=new BMenuItem("New Game",new BMessage(MENU_NEWGAME));
	B1->AddItem(B2);
	B2=new BMenuItem("About",new BMessage(MENU_ABOUT));
	B1->AddItem(B2);
	B2=new BMenuItem("Quit",new BMessage(MENU_QUIT));
	B1->AddItem(B2);

	T=Bounds();
	T.top+=20;
	
//	printf("Constructing Title view!\n");
	
	m_View=new TitelView(T);	

//	printf("Title view constructed\n");
	
	SetPulseRate(50);

	AddChild(B);
	AddChild(m_View);

//	printf("All window children added\n");
}

SameWindow::~SameWindow(void)
{
}

void	SameWindow::FrameMoved(BPoint screenPoint)
{
	m_View->WindowActivated(true);
}

void	SameWindow::MenusEnded(void) 
{
	m_View->WindowActivated(true);
}

bool 	SameWindow::QuitRequested(void)
{
	SaveHighscore();
	be_app->PostMessage(B_QUIT_REQUESTED);
	return (TRUE);
}

void	SameWindow::MessageReceived(BMessage *message)
{
	BRect	T;
	switch ( message->what )
	 {
		
	 	case MENU_NEWGAME:
			RemoveChild(m_View);
			delete(m_View);
			
			T=Bounds();
			T.top+=20;
			m_View=new PlayView(T);
			AddChild(m_View);
		 	break;

		case MENU_ABOUT:
			{
				BAlert	*T1=new BAlert("BeSame V1.1","BeSame V1.1\nBy Michael Wulff Nielsen (Naish@worldonline.dk).\nwww.coolcateditor.dk\n","Ok");
				T1->Go();
				m_View->WindowActivated(true);
			}
			break;

		case MENU_QUIT:
			be_app->PostMessage(B_QUIT_REQUESTED);
			break;		
		case MSG_GAMEOVER: 
		
			int32 Score;
			message->FindInt32("Score",&Score);
						 
			RemoveChild(m_View);
			delete(m_View);

			T=Bounds();
			T.top+=20;
			m_View=new GameOverView(T,Score);
			AddChild(m_View);
			break;

		case MSG_RETURNTOTITLE:
			RemoveChild(m_View);
			delete(m_View);

			T=Bounds();
			T.top+=20;
			m_View=new TitelView(T);
			AddChild(m_View);
			break;

		case MSG_TOHIGHSCORE:
			int32 Score1;
			message->FindInt32("Score",&Score1);
			RemoveChild(m_View);
			delete(m_View);

			T=Bounds();
			T.top+=20;
			m_View=new EnterNameView(T,Score1);
			AddChild(m_View);
			break;

		case MSG_HIGHSCOREENTRY:
			{
				int32 MyScore;
				message->FindInt32("Score",&MyScore);
				int i=0;

				while(MyScore<GameScores[i].Score)
					i++;
					printf("I: %d\n",i);
				for(int b=4;b>i;b--)
				{
					GameScores[b].Score=GameScores[b-1].Score;
					strcpy(&GameScores[b].Name[0],&GameScores[b-1].Name[0]);			
				}
					
				GameScores[i].Score=MyScore;
				const char*	t=message->FindString("Name");		
				strcpy(&GameScores[i].Name[0],t);
				
				RemoveChild(m_View);
				delete(m_View);

				T=Bounds();
				T.top+=20;
				m_View=new TitelView(T);
				AddChild(m_View);
				
			}
		default:
			BWindow::MessageReceived(message);
			break;
	}
}