#include "Titelview.h"
#include <be/translation/TranslationUtils.h>
#include <stdio.h>
#include "Hiscore.h"
#include <StorageKit.h>
#include <Window.h>

extern	BPath		GamePath;
extern	Hiscore		GameScores[5];

TitelView::TitelView(BRect T) : BView(T,"Titelview",B_FOLLOW_ALL_SIDES,B_FULL_UPDATE_ON_RESIZE|B_WILL_DRAW|B_PULSE_NEEDED)
{
	SetViewColor(0,0,0);
	
	BPath	P(GamePath);
	P.Append("Gfx/SameGameLogo.bmp");	
	
	printf("Attemting to load BMP file: %s\n",P.Path());
	m_Bitmap=BTranslationUtils::GetBitmap(P.Path());
	if(m_Bitmap==NULL)
	{
		printf("Error could not load Bitmap: %s\n",P.Path());
		printf("Bailing out!!!!!\n");
		exit(-1);
	}
	else
		printf("Loaded picture: %s\n",P.Path());

	int	pos=0;
	
	for(int i=0;i<256;i++)
	{
		m_Colors[pos][0]=33;
		m_Colors[pos][1]=00;
		m_Colors[pos++][2]=i;
	}	

	for(int i=255;i>=0;i--)
	{
		m_Colors[pos][0]=33;
		m_Colors[pos][1]=00;
		m_Colors[pos++][2]=i;
	}

	m_First=true;
	m_Pos=0;
	SetViewColor(B_TRANSPARENT_COLOR);
	m_Condition=1;
	
/*	for(int a=0;a<15;a++)
		for(int b=0;b<10;b++)
		{	
			SelectedMatrix[a][b]=false;
			
			Matrix[a][b].m_Type=a*b%3;
			Matrix[a][b].m_Frame=0;
			Matrix[a][b].m_Dirty=true;
		}
		
		BPoint	T(0,0);
		m_MousePoint=T;
		m_MouseInside=false;
		m_Score=0;		
*/
}

void	TitelView::WindowActivated(bool active)
{
	m_First=active;
}

void TitelView::Pulse()
{
	static	int	counter=0;
	
	counter++;
	
	if(counter==100)
	{
		if(m_Condition==1)
			m_Condition=2;
		else
			m_Condition=1;

		m_First=true;
		counter=0;
	}

	Invalidate();
}

void TitelView::Draw(BRect updateRect)
{
	if(m_First)
	{
		BRect	T=Bounds();
		FillRect(T);
		m_First=false;
	}
	
	BPoint	T(10,0);
	DrawBitmap(m_Bitmap,T);

	int	Temp;
	Temp=m_Pos;
	for(int i=0;i<480;i++)
	{
		BPoint	M(i,82);
		BPoint	M1(i,300);
		SetHighColor(m_Colors[Temp%512][0],m_Colors[Temp%512][1],m_Colors[Temp%512][2]);
		StrokeLine(M,M);
		StrokeLine(M1,M1);
		Temp++;
	}
	m_Pos+=5;
	
	
	if(m_Condition==1)
	{
		SetHighColor(0x55,0x99,0xcc);
		SetLowColor(0x22,0x22,0xaa);

		BFont	MyFont(be_bold_font);
		MyFont.SetSize(20);
		SetFont(&MyFont);


		MovePenTo(240-(MyFont.StringWidth("Programmed by:")/2),120);
		DrawString("Programmed by:");
		MovePenTo(240-(MyFont.StringWidth("Michael Wulff Nielsen")/2),140);
		DrawString("Michael Wulff Nielsen");
		
		MovePenTo(240-(MyFont.StringWidth("Graphics by:")/2),170);
		DrawString("Graphics by:");
		MovePenTo(240-(MyFont.StringWidth("Michael Wulff Nielsen")/2),190);
		DrawString("Michael Wulff Nielsen");
		MovePenTo(240-(MyFont.StringWidth("Jeppe Isaaksen")/2),210);
		DrawString("Jeppe Isaaksen");

		MyFont.SetSize(30);
		SetFont(&MyFont);
		MovePenTo(240-(MyFont.StringWidth("V1.1")/2),240);
		DrawString("V1.1");
/*		MovePenTo(240-(MyFont.StringWidth("Matthias Schonder")/2),260);
		DrawString("Matthias Schonder");
*/
	}
	else
	{
		SetHighColor(0x55,0x99,0xcc);
		SetLowColor(0x22,0x22,0xaa);

		BFont	MyFont(be_bold_font);
		MyFont.SetSize(20);
		SetFont(&MyFont);

		MovePenTo(240-(MyFont.StringWidth("High scores:")/2),120);
		DrawString("High scores:");


		int	y=165;
		char	temp[255];
		for(int i=0;i<5;i++)
		{
			sprintf(temp,"%d",GameScores[i].Score);	
			MovePenTo(20,y);
			DrawString(GameScores[i].Name);
			MovePenTo(460-MyFont.StringWidth(temp),y);
			DrawString(temp);
			y+=20;
		}
	
	}
	Flush();
}
